unit HTMLMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, FileCtrl, ShellAPI, HTMLCommon, ComCtrls, Clipbrd,
  ExtCtrls;

type
  Tfrm_Main = class(TForm)
    MainMenu1: TMainMenu;
    men_File: TMenuItem;
    men_Edit: TMenuItem;
    men_View: TMenuItem;
    men_ShortCuts: TMenuItem;
    men_Help: TMenuItem;
    men_New: TMenuItem;
    men_PreNew: TMenuItem;
    men_Open: TMenuItem;
    men_SaveAs: TMenuItem;
    men_Save: TMenuItem;
    N1: TMenuItem;
    men_PreImport: TMenuItem;
    men_PreExport: TMenuItem;
    men_ListImport: TMenuItem;
    men_ListExport: TMenuItem;
    N4: TMenuItem;
    men_Close: TMenuItem;
    men_Find: TMenuItem;
    men_Replace: TMenuItem;
    N2: TMenuItem;
    men_PresetEdit: TMenuItem;
    men_HTMLEdit: TMenuItem;
    N3: TMenuItem;
    men_Undo: TMenuItem;
    men_Redo: TMenuItem;
    men_UndoClear: TMenuItem;
    men_Ver: TMenuItem;
    dir_Directory: TDirectoryListBox;
    fil_File: TFileListBox;
    cmb_FileType: TComboBox;
    lst_HTML: TListBox;
    lbl_Description: TLabel;
    lbl_FileName: TLabel;
    lbl_Size: TLabel;
    lbl_ShortCut: TLabel;
    pop_Dummy: TPopupMenu;
    men_Short1: TMenuItem;
    men_Short2: TMenuItem;
    men_Short3: TMenuItem;
    men_Short4: TMenuItem;
    men_Short5: TMenuItem;
    men_Short6: TMenuItem;
    men_Short7: TMenuItem;
    men_Short8: TMenuItem;
    men_Short9: TMenuItem;
    men_Short10: TMenuItem;
    men_Short11: TMenuItem;
    men_Short12: TMenuItem;
    men_ShortClear: TMenuItem;
    men_Dark: TMenuItem;
    dlg_PresetOpen: TOpenDialog;
    dlg_PresetSave: TSaveDialog;
    dlg_HTMLOpen: TOpenDialog;
    dlg_HTMLSave: TSaveDialog;
    dlg_Font: TFontDialog;
    men_Font: TMenuItem;
    men_FindReplaceNext: TMenuItem;
    men_FindReplaceBack: TMenuItem;
    lbl_Pos: TLabel;
    men_WordWrap: TMenuItem;
    men_Encode: TMenuItem;
    men_ShiftJIS: TMenuItem;
    men_EUC: TMenuItem;
    men_UTF8: TMenuItem;
    men_Preview: TMenuItem;
    men_TextPrevier: TMenuItem;
    men_Option: TMenuItem;
    men_Count: TMenuItem;
    N5: TMenuItem;
    men_CRLF: TMenuItem;
    men_LF: TMenuItem;
    men_CR: TMenuItem;
    pgc_Text: TPageControl;
    pop_Tab: TPopupMenu;
    men_TabAdd: TMenuItem;
    men_TabDel: TMenuItem;
    pop_Memo: TPopupMenu;
    men_All: TMenuItem;
    men_UndoPop: TMenuItem;
    men_RedoPop: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    men_Copy: TMenuItem;
    men_Cut: TMenuItem;
    men_Paste: TMenuItem;
    men_UndoBuf: TMenuItem;
    drv_Drive: TDriveComboBox;
    pnl_Text: TPanel;
    mem_Text: TMemo;
    pnl_Top: TPanel;
    pnl_Directory: TPanel;
    Splitter1: TSplitter;
    pnl_File: TPanel;
    Splitter2: TSplitter;
    pnl_Tag: TPanel;
    Splitter3: TSplitter;
    pnl_Description: TPanel;
    Splitter4: TSplitter;
    Splitter5: TSplitter;
    pnl_Addition: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cmb_FileTypeChange(Sender: TObject);
    procedure men_OpenClick(Sender: TObject);
    procedure cmb_FileTypeKeyPress(Sender: TObject; var Key: Char);
    procedure men_SaveAsClick(Sender: TObject);
    procedure men_SaveClick(Sender: TObject);
    procedure lst_HTMLClick(Sender: TObject);
    procedure lst_HTMLDblClick(Sender: TObject);
    procedure lst_HTMLKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mem_TextKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mem_TextKeyPress(Sender: TObject; var Key: Char);
    procedure men_NewClick(Sender: TObject);
    procedure men_Short1Click(Sender: TObject);
    procedure men_DarkClick(Sender: TObject);
    procedure men_CloseClick(Sender: TObject);
    procedure men_PreNewClick(Sender: TObject);
    procedure men_PreImportClick(Sender: TObject);
    procedure men_PreExportClick(Sender: TObject);
    procedure men_ListImportClick(Sender: TObject);
    procedure men_ListExportClick(Sender: TObject);
    procedure men_Short2Click(Sender: TObject);
    procedure men_Short3Click(Sender: TObject);
    procedure men_Short4Click(Sender: TObject);
    procedure men_Short5Click(Sender: TObject);
    procedure men_Short6Click(Sender: TObject);
    procedure men_Short7Click(Sender: TObject);
    procedure men_Short8Click(Sender: TObject);
    procedure men_Short9Click(Sender: TObject);
    procedure men_Short10Click(Sender: TObject);
    procedure men_Short11Click(Sender: TObject);
    procedure men_Short12Click(Sender: TObject);
    procedure men_ShortClearClick(Sender: TObject);
    procedure men_FindClick(Sender: TObject);
    procedure men_ReplaceClick(Sender: TObject);
    procedure fil_FileKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure men_PresetEditClick(Sender: TObject);
    procedure men_HTMLEditClick(Sender: TObject);
    procedure men_FontClick(Sender: TObject);
    procedure men_VerClick(Sender: TObject);
    procedure men_FindReplaceNextClick(Sender: TObject);
    procedure men_FindReplaceBackClick(Sender: TObject);
    procedure mem_TextKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure mem_TextMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mem_TextMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure men_WordWrapClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure men_ShiftJISClick(Sender: TObject);
    procedure men_EUCClick(Sender: TObject);
    procedure men_UTF8Click(Sender: TObject);
    procedure men_PreviewClick(Sender: TObject);
    procedure men_TextPrevierClick(Sender: TObject);
    procedure men_UndoClearClick(Sender: TObject);
    procedure men_RedoClick(Sender: TObject);
    procedure men_UndoClick(Sender: TObject);
    procedure men_CountClick(Sender: TObject);
    procedure men_CRLFClick(Sender: TObject);
    procedure men_LFClick(Sender: TObject);
    procedure men_CRClick(Sender: TObject);
    procedure men_TabAddClick(Sender: TObject);
    procedure men_TabDelClick(Sender: TObject);
    procedure pgc_TextChange(Sender: TObject);
    procedure men_AllClick(Sender: TObject);
    procedure mem_TextChange(Sender: TObject);
    procedure men_CutClick(Sender: TObject);
    procedure men_CopyClick(Sender: TObject);
    procedure men_PasteClick(Sender: TObject);
    procedure men_UndoBufClick(Sender: TObject);
  private
    { Private 錾 }
    procedure SetConfig;
    procedure SetFileType;
    procedure InitializePreset;
    procedure DecodeHtmlList;
    procedure InitializeHtmlList;
    procedure SetFileSize;
    procedure GetPos(var ACol, ARow: Integer);
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
  public
    { Public 錾 }
    procedure SetHtmlList;
    procedure SetHTMLDesc(Index: Integer);
    procedure PasteHtml(Index: Integer);
    procedure SaveFile(FileName: String);
    procedure SetShortCut(Num, Index: Integer);
    procedure FindString(const Search: String; RegFlg, RevFlg: Boolean);
    procedure ReplaceString(const Search, Replace: String;
      RegFlg, CrLfFlg, RevFlg: Boolean);
    function StrEncode(const S: String; EnCode: Integer): String;
    function StrDecode(const S: String; EnCode: Integer): String;
    procedure UndoAdd(UNData: TUndo);
    function NameGet(ReadData, AnotherName: String): String;
  end;

  procedure TimerProc(hwindow:HWND; Msg:UINT; ID:UINT; dwTime:DWORD); stdcall;

var
  frm_Main: Tfrm_Main;
  MultiTab: Array of TTabSheet;
  TabString: Array of String;
  TabPoint: Array of Integer;
  TabId: Integer;
  IntParam: Integer;
  FilePath: Array of String;
  SaveLeft: Integer;
  SaveTop: Integer;
  SaveWidth: Integer;
  SaveHeight: Integer;
  NowCode: Integer = SHIFT_JIS;
  BRCode: String = #13#10;

  UndoStart: Integer = 0;
  UndoSelText: String = '';
  UndoFlg: Boolean = False;
  RedoFlg: Boolean = False;
  TabFlg: Boolean = False;
  Processes: Array of Integer;
  TmpFileName: Array of String;
  TimerId: Integer = 101;

implementation

uses
  HTMLSave, HTMLFindReplace, HTMLPresetEdit, HTMLListEdit, HTMLVersion,
  VBScript_RegExp_55_TLB;

{$R *.dfm}

procedure Tfrm_Main.fil_FileKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = Vk_Return then
    men_Open.Click;
end;

procedure Tfrm_Main.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  mr: Integer;
  ConfStr: TStringList;
  i, j: Integer;

begin
  for i := 0 to pgc_Text.PageCount - 1 do
  begin
    if LoadData[i] <> TabString[i] then
    begin
      mr := MessageDlg(html_message1, mtInformation, [mbYes, mbYesToAll, mbNo, mbNoToAll, mbCancel], -1);
      if mr = mrYes then
      begin
        pgc_Text.ActivePageIndex := i;
        pgc_TextChange(Self);
        if FilePath[TabId] = '' then
        begin
          if frm_SaveAs.ShowModal = mrCancel then
          begin
            CanClose := False;
            Exit;
          end;
        end
        else
          SaveFile(FilePath[TabId]);
      end
      else if mr = mrYesToAll then
      begin
        for j := 0 to pgc_Text.PageCount - 1 do
        begin
          if LoadData[j] <> TabString[j] then
          begin
            pgc_Text.ActivePageIndex := j;
            pgc_TextChange(Self);
            if FilePath[TabId] = '' then
              frm_SaveAs.ShowModal
            else
              SaveFile(FilePath[TabId]);
          end;
        end;

        break;
      end
      else if mr = mrNoToAll then
        break
      else if mr = mrCancel then
      begin
        CanClose := False;
        Exit;
      end;
    end;
  end;

  ChDir(CurrentPath);

  // RtBO̕ۑ
  ConfStr := TStringList.Create;

  try
    ConfStr.Add('FilePath=' + dir_Directory.Directory);
    for i := 1 to 12 do
      ConfStr.Add('HTMLShort' + IntToStr(i) + '=' + IntToStr(HTMLShort[i]));
    ConfStr.Add('FileType=' + IntToStr(cmb_FileType.ItemIndex));
    if men_Dark.Checked then
      ConfStr.Add('DispColor=Dark')
    else
      ConfStr.Add('DispColor=Light');
    if Self.WindowState = wsNormal then
    begin
      SaveWidth :=  Self.Width;
      SaveHeight := Self.Height;
      SaveLeft := Self.Left;
      SaveTop := Self.Top;
    end;
    ConfStr.Add('Left=' + IntToStr(SaveLeft));
    ConfStr.Add('Top=' + IntToStr(SaveTop));
    ConfStr.Add('Width=' + IntToStr(SaveWidth));
    ConfStr.Add('Height=' + IntToStr(SaveHeight));
    ConfStr.Add('S1=' + IntToStr(pnl_Directory.Width));
    ConfStr.Add('S2=' + IntToStr(pnl_File.Width));
    ConfStr.Add('S3=' + IntToStr(pnl_Tag.Width));
    ConfStr.Add('S4=' + IntToStr(pnl_Top.Height));
    ConfStr.Add('S5=' + IntToStr(pnl_Text.Height));
    if Self.WindowState = wsMaximized then
      ConfStr.Add('WindowSize=Maximized')
    else if Self.WindowState = wsMinimized then
      ConfStr.Add('WindowSize=Minimized')
    else
      ConfStr.Add('WindowSize=Normal');
    ConfStr.Add('FontSize=' + IntToStr(mem_Text.Font.Size));
    ConfStr.Add('FontType=' + mem_Text.Font.Name);
    if men_ShiftJIS.Checked then
      ConfStr.Add('EncType=SHIFT_JIS')
    else if men_EUC.Checked then
      ConfStr.Add('EncType=EUC_JP')
    else if men_UTF8.Checked then
      ConfStr.Add('EncType=UTF_8');
    if men_ShiftJIS.Checked then
      ConfStr.Add('BRType=CRLF')
    else if men_EUC.Checked then
      ConfStr.Add('BRType=LF')
    else if men_UTF8.Checked then
      ConfStr.Add('BRType=CR');
    if men_WordWrap.Checked then
      ConfStr.Add('WordWrap=True')
    else
      ConfStr.Add('WordWrap=False');
    ConfStr.Add('UndoMax=' + IntToStr(UndoMax));

    ConfStr.SaveToFile(html_config);
  except
    MessageBeep(MB_ICONHAND);
    MessageDlg(html_error4, mtError, [mbOk], -1);
  end;

  ConfStr.Free;

  // vZbg̕ۑ
  try
    PresetList.SavetoFile(html_preset);
  except
    MessageBeep(MB_ICONHAND);
    MessageDlg(html_error6, mtError, [mbOk], -1);
  end;

  PresetList.Free;

  // HTMLXg̕ۑ
  try
    HTMLList.SaveToFile(html_list);
  except
    MessageBeep(MB_ICONHAND);
    MessageDlg(html_error1, mtError, [mbOk], -1);
  end;

  HTMLList.Free;
  HTMLList1.Free;
  HTMLList2.Free;

  // ^C}[֘Ǎ㏈
  if Length(Processes) > 0 then
  begin
    for i := 0 to Length(Processes) do
      DeleteFile(TmpFileName[i]);
    KillTimer(Handle, TimerId);
  end;
end;

procedure Tfrm_Main.FormCreate(Sender: TObject);
begin
  // LvṼZbg
  Caption := html_title;

  // ^ȕ
  SetLength(MultiTab, 1);
  TabId := 0;
  MultiTab[0] := TTabSheet.Create(Self);
  MultiTab[0].Caption := html_caption7;
  MultiTab[0].PageControl := pgc_Text;
  MultiTab[0].HandleNeeded;
  mem_Text.Parent := MultiTab[0];

  // vZbgZNV
  PresetList := TStringList.Create;

  if FileExists(html_preset) then
    PresetList.LoadFromFile(html_preset)
  else
    InitializePreset;

  // HTMLXgZNV
  HTMLList := TStringList.Create;
  HTMLList1 := TStringList.Create;
  HTMLList2 := TStringList.Create;
  DescList := TStringList.Create;

  if FileExists(html_list) then
  begin
    HTMLList.LoadFromFile(html_list);
    DecodeHtmlList;
  end
  else
  begin
    InitializeHtmlList;
    DecodeHtmlList;
  end;

  SetHtmlList;

  // t@C^CvZNV
  SetFileType;

  // RtBOZNV
  SetConfig;

  // AhD̒ݒ
  SetLength(UndoList, 1);
  SetLength(UndoList[0], UndoMax);
  SetLength(UndoPoint, 1);
  UndoPoint[0] := 0;
  SetLength(UndoLength, 1);
  UndoLength[0] := 0;

  // t@ChbOhbvX^[g
  DragAcceptFiles(Handle, True);

  // ^C}[pz̐ݒ
  SetLength(Processes, 0);
  SetLength(TmpFileName, 0);
end;

procedure Tfrm_Main.FormShow(Sender: TObject);
var
  LoadFile: TextFile;
  LoadChar: Char;
  LoadText: String;

begin
  if FilePath[TabId] = '' then
    Exit;

  if FileExists(FilePath[TabId]) then
  begin
    AssignFile(LoadFile, FilePath[TabId]);

    try
      Reset(LoadFile);

      LoadText := '';
      while not(EOF(LoadFile)) do
      begin
        Read(LoadFile, LoadChar);
        Insert(LoadChar, LoadText, Length(LoadText) + 1);
      end;

      CloseFile(LoadFile);

      if Pos(#13#10, LoadText) = 0 then
      begin
        if Pos(#13, LoadText) <> 0 then
          LoadText := StringReplace(LoadText, #13, #13#10, [rfReplaceAll])
        else if Pos(#10, LoadText) <> 0 then
          LoadText := StringReplace(LoadText, #10, #13#10, [rfReplaceAll]);
      end;
      mem_Text.Text := StrDecode(LoadText, NowCode);
      LoadData[TabId] := mem_Text.Text;

      Caption := html_title + ' - ' + FilePath[TabId];
      if Copy(FilePath[TabId], Length(FilePath[TabId]) - 4, 5) = '.html' then
        MultiTab[TabId].Caption := NameGet(LoadData[TabId], ExtractFileName(fil_File.FileName))
      else
        MultiTab[TabId].Caption := ExtractFileName(fil_File.FileName);
      MultiTab[TabId].Caption := ExtractFileName(FilePath[TabId]);
      lbl_FileName.Caption := FilePath[TabId];
      SetFileSize;

      men_UndoClear.Click;
    except
      try
        CloseFile(LoadFile)
      except
      end;
      MessageBeep(MB_ICONHAND);
      MessageDlg(html_error2, mtError, [mbOk], -1);
    end;
  end
  else
  begin
    MessageBeep(MB_ICONEXCLAMATION);
    MessageDlg(html_error3, mtWarning, [mbOk], -1);
  end;
end;

procedure Tfrm_Main.SetConfig;
var
  ConfList: TStringList;
  i, j: Integer;

begin
  ConfList := TStringList.Create;

  if FileExists(html_config) then
  begin
    ConfList.LoadFromFile(html_config);

    // pX̎擾
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('FilePath', ConfList[j]) <> 0 then
      begin
        if DirectoryExists(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j]))) then
        begin
          dir_Directory.Directory := Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j]));
          fil_File.Directory := dir_Directory.Directory;
        end;

        ConfList.Delete(j);
        break;
      end;
    end;

    // V[gJbg̎擾
    for i := 1 to 12 do
    begin
      for j := 0 to ConfList.Count - 1 do
      begin
        if Pos('HTMLShort' + IntToStr(i), ConfList[j]) <> 0 then
        begin
          try
            SetShortCut(i, StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j]))));
          except
            SetShortCut(i, -1);
          end;
          ConfList.Delete(j);
          break;
        end;
      end;
    end;

    // t@C^Cv̎擾
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('FileType', ConfList[j]) <> 0 then
      begin
        try
          cmb_FileType.ItemIndex := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
          cmb_FileTypeChange(Self);
        except

        end;
        ConfList.Delete(j);
        break;
      end;
    end;

    // ʐF̎擾
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('DispColor', ConfList[j]) <> 0 then
      begin
        if Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])) = 'Dark' then
          men_Dark.Click;
        ConfList.Delete(j);
        break;
      end;
    end;

    // ʒuTCY̎擾
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('Left', ConfList[j]) <> 0 then
      begin
        try
          Self.Left := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          Self.Left := Default_Left;
        end;
        SaveLeft := Self.Left;

        ConfList.Delete(j);
        break;
      end
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('Top', ConfList[j]) <> 0 then
      begin
        try
          Self.Top := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          Self.Top := Default_Top;
        end;
        SaveTop := Self.Top;

        ConfList.Delete(j);
        break;
      end;
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('Width', ConfList[j]) <> 0 then
      begin
        try
          Self.Width := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          Self.Width := Default_Width;
        end;
        SaveWidth := Self.Width;

        ConfList.Delete(j);
        break;
      end
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('S1', ConfList[j]) <> 0 then
      begin
        try
          pnl_Directory.Width := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          pnl_Directory.Width := 168;
        end;

        ConfList.Delete(j);
        break;
      end
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('S2', ConfList[j]) <> 0 then
      begin
        try
          pnl_File.Width := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          pnl_File.Width := 168;
        end;

        ConfList.Delete(j);
        break;
      end
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('S3', ConfList[j]) <> 0 then
      begin
        try
          pnl_File.Width := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          pnl_File.Width := 168;
        end;

        ConfList.Delete(j);
        break;
      end
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('S4', ConfList[j]) <> 0 then
      begin
        try
          pnl_Top.Height := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          pnl_Top.Height := 122;
        end;

        ConfList.Delete(j);
        break;
      end
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('S5', ConfList[j]) <> 0 then
      begin
        try
          pnl_Text.Height := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          pnl_Text.Height := 536;
        end;

        ConfList.Delete(j);
        break;
      end
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('Height', ConfList[j]) <> 0 then
      begin
        try
          Self.Height := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          Self.Height := Default_Height;
        end;
        SaveHeight := Self.Height;

        ConfList.Delete(j);
        break;
      end;
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('WindowSize', ConfList[j]) <> 0 then
      begin
        if Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])) = 'Maximized' then
          Self.WindowState := wsMaximized
        else if Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])) = 'Minimized' then
          Self.WindowState := wsMinimized
        else
          Self.WindowState := wsNormal;

        ConfList.Delete(j);
        break;
      end;
    end;

    // tHg̎擾
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('FontSize', ConfList[j]) <> 0 then
      begin
        try
          mem_Text.Font.Size := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          mem_Text.Font.Size := 11;
        end;

        ConfList.Delete(j);
        break;
      end;
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('FontType', ConfList[j]) <> 0 then
      begin
        try
          mem_Text.Font.Name := Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j]));
        except
          mem_Text.Font.Name := 'lr SVbN';
        end;

        ConfList.Delete(j);
        break;
      end;
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('EncType', ConfList[j]) <> 0 then
      begin
        if Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])) = 'SHIFT_JIS' then
          men_ShiftJIS.Click
        else if Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])) = 'EUC_JP' then
          men_EUC.Click
        else if Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])) = 'UTF_8' then
          men_UTF8.Click;

        ConfList.Delete(j);
        break;
      end;
    end;
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('BRType', ConfList[j]) <> 0 then
      begin
        if Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])) = 'CRLF' then
          men_CRLF.Click
        else if Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])) = 'LF' then
          men_LF.Click
        else if Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])) = 'CR' then
          men_CR.Click;

        ConfList.Delete(j);
        break;
      end;
    end;

    // ̎擾
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('WordWrap', ConfList[j]) <> 0 then
      begin
        if Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])) = 'False' then
          men_WordWrap.Click;
      end;
    end;

    // AhDobt@̐[擾
    for j := 0 to ConfList.Count - 1 do
    begin
      if Pos('UndoMax', ConfList[j]) <> 0 then
      begin
        try
          UndoMax := StrToInt(Copy(ConfList[j], Pos('=', ConfList[j]) + 1, Length(ConfList[j])));
        except
          UndoMax := UndoMax_Default;
        end;

        ConfList.Delete(j);
        break;
      end;
    end;
  end
  else
  begin
    // V[gJbg̐ݒ
    for i := 1 to 12 do
      SetShortCut(i, -1);

    // ʒuTCY̐ݒ
    Self.Left := Default_Left;
    Self.Top := Default_Top;
    Self.Width := Default_Width;
    Self.Height := Default_Height;
    SaveLeft := Self.Left;
    SaveTop := Self.Top;
    SaveWidth := Self.Width;
    SaveHeight := Self.Height;
    pnl_Directory.Width := 168;
    pnl_File.Width := 168;
    pnl_File.Width := 168;
    pnl_Top.Height := 122;
    pnl_Text.Height := 536;
  end;

  ConfList.Free;
end;

procedure Tfrm_Main.SetFileType;
var
  i: Integer;

begin
  // t@C^Cv̐ݒ
  cmb_FileType.Clear;

  for i := 0 to TypeCnt - 1 do
    cmb_FileType.Items.Add(FileTypes[i].PaternName);

  cmb_FileType.ItemIndex := 0;
  fil_File.Mask := '*' + FileTypes[0].Patern;
end;

procedure Tfrm_Main.cmb_FileTypeChange(Sender: TObject);
begin
  if (cmb_FileType.ItemIndex >= 0) and (cmb_FileType.ItemIndex < TypeCnt) then
    fil_File.Mask := '*' + FileTypes[cmb_FileType.ItemIndex].Patern;
end;

procedure Tfrm_Main.cmb_FileTypeKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0;
end;

procedure Tfrm_Main.InitializePreset;
begin
  PresetList.Clear;

  PresetList.Add(' <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">');
  PresetList.Add('<html>');
  PresetList.Add('<head>');
  PresetList.Add('<title>^Cg</title>');
  PresetList.Add('<meta http-equiv="Content-Type" content="text/html; charaset=shift_jis">');
  PresetList.Add('<meta http-equiv="Content-Style-Type" content="text/css">');
  PresetList.Add('<meta name="generator" content="HTMLEditor">');
  PresetList.Add('</head>');
  PresetList.Add('<body bgcolor="#ffffff" text="#000000" link="#ff0000" vlink="#880088" alink="#888800">');
  PresetList.Add('');
  PresetList.Add('</body>');
  PresetList.Add('</html>');
end;

procedure Tfrm_Main.DecodeHtmlList;
var
  i: Integer;
  HTMLStr: String;

begin
  HTMLList1.Clear;
  HTMLList2.Clear;

  for i := 0 to HTMLList.Count - 1 do
  begin
    HTMLStr := HTMLList[i];
    HTMLList1.Add(Copy(HTMLStr, 1, Pos(#9, HTMLStr) - 1));
    Delete(HTMLStr, 1, Pos(#9, HTMLStr));
    HTMLList2.Add(Copy(HTMLStr, 1, Pos(#9, HTMLStr) - 1));
    Delete(HTMLStr, 1, Pos(#9, HTMLStr));
    DescList.Add(HTMLStr);
  end;
end;

procedure Tfrm_Main.InitializeHtmlList;
begin
  // Xgt@CȂ̏ݒ
  HTMLList.Clear;

  HTMLList.Add(' <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">' + #9 + #9 + 'hbN^Cv錾');
  HTMLList.Add('<html>' + #9 + '</html>' + #9 + 'HTMLiŚj');
  HTMLList.Add('<head>' + #9 + '</head>' + #9 + 'wb_');
  HTMLList.Add('<title>' + #9 + '</title>' + #9 + '^Cg');
  HTMLList.Add('<meta http-equiv="Content-Type" content="text/html; charaset=shift_jis">' + #9 + #9 + 'R[hwFSHIFT_JIS');
  HTMLList.Add('<meta http-equiv="Content-Type" content="text/html; charaset=euc-jp">' + #9 + #9 + 'R[hwFEUC');
  HTMLList.Add('<meta http-equiv="Content-Type" content="text/html; charaset=iso-2022-jp">' + #9#9 + 'R[hwFISO-2022');
  HTMLList.Add('<meta name="description" content="̐">' + #9 + #9 + 'HTML̐');
  HTMLList.Add('<meta name="keywords" content="L[[h">' + #9 + #9 + 'L[[h');
  HTMLList.Add('<meta name="robots" content="noindex">' + #9 + #9 + '{bg֎~');
  HTMLList.Add('<meta name="robots" content="nofollow">' + #9 + #9 + '{bg֎~');
  HTMLList.Add('<meta http-equiv="Content-Style-Type" content="text/css">' + #9 + #9 + 'X^CV[g̐ݒ');
  HTMLList.Add('<meta http-equiv="Content-Script-Type" content="text/javascript">' + #9 + #9 + 'JavaScript̐ݒ');
  HTMLList.Add('<meta http-equiv="refresh" content="5; url=WvURL">' + #9 + #9 + 'N');
  HTMLList.Add('<meta http-equiv="refresh" content="5">' + #9 + #9 + 'XV');
  HTMLList.Add('<meta http-equiv="pragma" content="no-cache">' + #9 + #9 + 'LbV̋֎~');
  HTMLList.Add('<meta http-equiv="cache-control" content="no-cache">' + #9 + #9 + 'LbV̋֎~');
  HTMLList.Add('<meta http-equiv="expires" content="LbV̊">' + #9 + #9 + 'LbV̊ݒ');
  HTMLList.Add('<meta name="author" content="҂̖O">' + #9 + #9 + 'Җݒ');
  HTMLList.Add('<meta name="generator" content="HTMLEditor">' + #9 + #9 + 'HTMLr_[̐ݒ');
  HTMLList.Add('<body background="obNOhURL" bgcolor="#ffffff" text="#000000" link="#ff0000" vlink="#880088" alink="#888800">' + #9 + '</body>' + #9 + '{fB̐ݒ');
  HTMLList.Add('<bgsound src="URI" repeat="s[g">' + #9 + #9 + 'BGMݒ');
  HTMLList.Add('<h1>' + #9 + '</h1>' + #9 + '\');
  HTMLList.Add('<h2>' + #9 + '</h2>' + #9 + '\');
  HTMLList.Add('<h3>' + #9 + '</h3>' + #9 + '\');
  HTMLList.Add('<h4>' + #9 + '</h4>' + #9 + '\');
  HTMLList.Add('<h5>' + #9 + '</h5>' + #9 + '\');
  HTMLList.Add('<h6>' + #9 + '</h6>' + #9 + '\');
  HTMLList.Add('<font size="傫̎w" color="#000000">' + #9 + '</font>' + #9 + 'tHg̎w');
  HTMLList.Add('<pre>' + #9 + '</pre>' + #9 + 'v[eLXg');
  HTMLList.Add('<b>' + #9 + '</b>' + #9 + '');
  HTMLList.Add('<i>' + #9 + '</i>' + #9 + 'C^bN');
  HTMLList.Add('<u>' + #9 + '</u>' + #9 + 'A_[o[');
  HTMLList.Add('<strike>' + #9 + '</strike>' + #9 + 'ł');
  HTMLList.Add('<br>' + #9 + #9 + 's');
  HTMLList.Add('<hr>' + #9 + #9 + 'r');
  HTMLList.Add('<center>' + #9 + '</center>' + #9 + '');
  HTMLList.Add('<p align="̈ʒu" valign="c̈ʒu">' + #9 + '</p>' + #9 + 'iݒ');
  HTMLList.Add('<ruby>' + #9 + '<rp>i</rp><rt>r</rt><rp>j</rp></ruby>' + #9 + 'r̎w');
  HTMLList.Add('<a href="URI" name="O" taget="^[Qbg">' + #9 + '</a>' + #9 + 'N');
  HTMLList.Add('<img src="URI" border="g" width="" height="c" alt="֕">' + #9 + #9 + 'C[W̓\t');
  HTMLList.Add('<embed src="URI" width="" height="c">' + #9 + #9 + 'yEtbV̓\t');
  HTMLList.Add('<noembed>' + #9 + '</embed>' + #9 + 'HTML̐' + #9 + 'EMBED^OΉuEUւ̕\');
  HTMLList.Add('<object data="URL" type="t@C^Cv" width="" height="c">' + #9 + #9 + 'IuWFNg̓\t');
  HTMLList.Add('<applet code="URI" width="" height="c">' + #9 + '</applet>' + #9 + 'Avbg̓\t');
  HTMLList.Add('<param name="p[^̖O" value="p[^̒l">' + #9 + #9 + 'Avbgݒ');
  HTMLList.Add('<table border="g" bordercolor="#000000" width="" cellspacing="Z̏c" cellpadding="Z̉">' + #9 + '</table>' + #9 + 'e[u\');
  HTMLList.Add('<tr>' + #9 + '</tr>' + #9 + 'e[us');
  HTMLList.Add('<th bgcolor="#ffffff" widht="">' + #9 + '</th>' + #9 + '');
  HTMLList.Add('<td bgcolor="#ffffff" width="" align="̈ʒu" valign="c̈ʒu">' + #9 + '</td>' + #9 + 'e[uJ');
  HTMLList.Add('<thead>' + #9 + '</thead>' + #9 + 'e[uos');
  HTMLList.Add('<tbody>' + #9 + '</tbody>' + #9 + 'e[ues');
  HTMLList.Add('<tfoot>' + #9 + '</tfoot>' + #9 + 'e[uos');
  HTMLList.Add('<frameset rows="t[̏c" cols="t[̏c">' + #9 + '</frameset>' + #9 + 't[\');
  HTMLList.Add('<frame src="URL" name="O">' + #9 + #9 + 't[EBhE̐ݒ');
  HTMLList.Add('<noframe>' + #9 + '</noframe>' + #9 + 't[ΉuEUւ̕\');
  HTMLList.Add('<form name="O" action="URI" taeget="^[Qbg" method="GETPOST" enctype="multipart/form-data">' + #9 + '</form>' + #9 + 'tH[̐ݒ');
  HTMLList.Add('<input type="text" name="O" value="\" size=""@maxlength="ő͕">' + #9 + #9 + 'eLXg{bNX');
  HTMLList.Add('<input type="password" name="O" size=""@maxlength="ő͕">' + #9 + #9 + 'pX[h{bNX');
  HTMLList.Add('<input type="checkbox" name="O" value="l">' + #9 + #9 + '`FbN{bNX');
  HTMLList.Add('<input type="radio" name="O" value="l">' + #9 + #9 + 'WI{bNX');
  HTMLList.Add('<input type="file" name="O" value="l" size="">' + #9 + #9 + 't@C{bNX');
  HTMLList.Add('<input type="hidden" name="O" value="l">' + #9 + #9 + 'Bp[^');
  HTMLList.Add('<input type="submit" value="M">' + #9 + #9 + 'M{^');
  HTMLList.Add('<input type="reset" value="Zbg">' + #9 + #9 + 'Zbg{^');
  HTMLList.Add('<input type="button" value="{^">' + #9 + #9 + '{^');
  HTMLList.Add('<input type="image" src="URL">' + #9 + #9 + 'C[W{^');
  HTMLList.Add('<select name="O" size="c̐">' + #9 + '</select>' + #9 + 'ZNg{bNX');
  HTMLList.Add('<option value="l">' + #9 + '</option>' + #9 + 'ZNgACe');
  HTMLList.Add('<textarea name="O" rowspan="c" colspan="">' + #9 + '</textarea>' + #9 + 'eLXgGA');
end;

procedure Tfrm_Main.lst_HTMLClick(Sender: TObject);
begin
  SetHTMLDesc(lst_HTML.ItemIndex);
end;

procedure Tfrm_Main.lst_HTMLDblClick(Sender: TObject);
begin
  PasteHTML(lst_HTML.ItemIndex);
end;

procedure Tfrm_Main.lst_HTMLKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = Vk_Return then
  begin
    PasteHTML(lst_HTML.ItemIndex);
    SetHTMLDesc(lst_HTML.ItemIndex);
  end
  else if Key in [Vk_Up, Vk_Down, Vk_Left, Vk_Right, Vk_Prior, Vk_Next, Vk_Home, Vk_End] then
    SetHTMLDesc(lst_HTML.ItemIndex);
end;

procedure Tfrm_Main.mem_TextChange(Sender: TObject);
var
  UNData: TUndo;
  UndoEnd: Integer;

begin
  if UndoFlg or RedoFlg then
  begin
    TabString[TabId] := mem_Text.Text;
    Exit;
  end
  else if TabFlg then
    Exit;

  if mem_Text.Text = TabString[TabId] then
    Exit;

  UndoEnd := mem_Text.SelStart;

  if Length(UndoSelText) > 0 then
  begin
    UNData.UndoType := unDelete;
    UNData.UndoStartPoint := UndoStart;
    UNData.UndoEndPoint := UndoEnd;
    UNData.MotoStr := UndoSelText;
    UNData.HendoStr := Copy(mem_Text.Text, UndoStart + 1, UndoEnd - UndoStart);
    UndoAdd(UNData);

    UndoSelText := '';

    if Length(UNData.HendoStr) > 0 then
    begin
      UNData.UndoType := unInsert;
      UndoAdd(UNData);
    end;
  end
  else
  begin
    if Length(mem_Text.Text) > Length(TabString[TabId]) then
    begin
      UNData.UndoType := unInsert;
      UNData.UndoStartPoint := UndoStart;
      UNData.UndoEndPoint := UndoEnd;
      UNData.MotoStr := '';
      UNData.HendoStr := Copy(mem_Text.Text, UndoStart + 1, UndoEnd - UndoStart);
      UndoAdd(UNData);
    end
    else
    begin
      UNData.UndoType := unDelete;
      UNData.UndoStartPoint := UndoStart;
      UNData.UndoEndPoint := UndoEnd;
      UNData.HendoStr := '';
      if UndoEnd >= UndoStart then
        UNData.MotoStr := Copy(TabString[TabId], UndoStart + 1, Length(TabString[TabId]) - Length(mem_Text.Text))
      else
        UNData.MotoStr := Copy(TabString[TabId], UndoEnd + 1, Length(TabString[TabId]) - Length(mem_Text.Text));
      UndoAdd(UNData);
    end;
  end;

  UndoStart := UndoEnd;
  TabString[TabId] := mem_Text.Text;
end;

procedure Tfrm_Main.mem_TextKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i: Integer;
  ARow: Integer;
  ACol: Integer;
  TabText: String;
  TextList: TStringList;

begin
  UndoStart := mem_Text.SelStart;
  UndoSelText := mem_Text.SelText;

  GetPos(ACol, ARow);
  lbl_Pos.Caption := IntToStr(ARow) + 's' + IntToStr(ACol) + '';

  if Key = Vk_Return then
  begin
    i := 1;
    TabText := #13#10;
    TextList := TStringList.Create;
    TextList.Text := mem_Text.Text;
    if TextList.Text <> '' then
    begin
      if ARow >= TextList.Count then
        ARow := TextList.Count - 1;
      while True do
      begin
        if i > Length(TextList[ARow]) then
          break;

        if TextList[ARow][i] = #9 then
        begin
          TabText := TabText + #9;
          i := i + 1;
        end
        else
          break;
      end;
    end;
    ACol := mem_Text.SelStart;
    mem_Text.Perform(EM_REPLACESEL, 1, LongInt(PChar(TabText)));
  end;
end;

procedure Tfrm_Main.mem_TextKeyPress(Sender: TObject; var Key: Char);
begin
  if VkKeyScan(Key) = Vk_Return then
    Key := #0;
end;

procedure Tfrm_Main.mem_TextKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ACol, ARow: Integer;

begin
  UndoStart := mem_Text.SelStart;
  UndoSelText := mem_Text.SelText;

  GetPos(ACol, ARow);
  lbl_Pos.Caption := IntToStr(ARow) + 's' + IntToStr(ACol) + '';
end;

procedure Tfrm_Main.mem_TextMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  ACol, ARow: Integer;

begin
  UndoStart := mem_Text.SelStart;
  UndoSelText := mem_Text.SelText;

  GetPos(ACol, ARow);
  lbl_Pos.Caption := IntToStr(ARow) + 's' + IntToStr(ACol) + '';
end;

procedure Tfrm_Main.mem_TextMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  ACol, ARow: Integer;

begin
  UndoStart := mem_Text.SelStart;
  UndoSelText := mem_Text.SelText;

  GetPos(ACol, ARow);
  lbl_Pos.Caption := IntToStr(ARow) + 's' + IntToStr(ACol) + '';
end;

procedure Tfrm_Main.men_AllClick(Sender: TObject);
begin
  mem_Text.SelectAll;
end;

procedure Tfrm_Main.men_CloseClick(Sender: TObject);
begin
  Close;
end;

procedure Tfrm_Main.men_CopyClick(Sender: TObject);
var
  Clip: TClipboard;

begin
  Clip := Clipboard;

  if mem_Text.SelLength > 0 then
    Clip.AsText := mem_Text.SelText;
end;

procedure Tfrm_Main.men_CountClick(Sender: TObject);
var
  Cnt: Integer;

begin
  if MessageDlg(html_message10, mtConfirmation, [mbYes, mbNo], -1) = mrNo then
    Exit;

  Cnt := Length(WideString(StringReplace(mem_Text.Text, #13#10, #13, [rfReplaceAll])));
  ShowMessage(IntToStr(Cnt) + '');
end;

procedure Tfrm_Main.men_CRClick(Sender: TObject);
begin
  BRCode := #13;

  men_CRLF.Checked := False;
  men_LF.Checked := True;
  men_CR.Checked := False;
end;

procedure Tfrm_Main.men_CRLFClick(Sender: TObject);
begin
  BRCode := #13#10;

  men_CRLF.Checked := True;
  men_LF.Checked := False;
  men_CR.Checked := False;
end;

procedure Tfrm_Main.men_CutClick(Sender: TObject);
var
  Clip: TClipboard;

begin
  Clip := Clipboard;

  if mem_Text.SelLength > 0 then
  begin
    Clip.AsText := mem_Text.SelText;
    mem_Text.SelText := '';
  end;
end;

procedure Tfrm_Main.men_DarkClick(Sender: TObject);
begin
  if men_Dark.Checked then
  begin
    // 邭
    Color := clBtnFace;

    drv_Drive.Color := clWindow;
    dir_Directory.Color := clWindow;
    fil_File.Color := clWindow;
    cmb_FileType.Color := clWindow;
    lst_HTML.Color := clWindow;
    mem_Text.Color := clWindow;

    Font.Color := clWindowText;

    drv_Drive.Font.Color := clWindowText;
    dir_Directory.Font.Color := clWindowText;
    fil_File.Font.Color := clWindowText;
    cmb_FileType.Font.Color := clWindowText;
    lst_HTML.Font.Color := clWindowText;
    mem_Text.Font.Color := clWindowText;

    men_Dark.Checked := False;
  end
  else
  begin
    // Â
    Color := clGray;

    drv_Drive.Color := clBlack;
    dir_Directory.Color := clBlack;
    fil_File.Color := clBlack;
    cmb_FileType.Color := clBlack;
    lst_HTML.Color := clBlack;
    mem_Text.Color := clBlack;

    Font.Color := clWhite;

    drv_Drive.Font.Color := clWhite;
    dir_Directory.Font.Color := clWhite;
    fil_File.Font.Color := clWhite;
    cmb_FileType.Font.Color := clWhite;
    lst_HTML.Font.Color := clWhite;
    mem_Text.Font.Color := clWhite;

    men_Dark.Checked := True;
  end;

  // ʍĕ`
  drv_Drive.Visible := False;
  dir_Directory.Visible := False;
  fil_File.Visible := False;
  cmb_FileType.Visible := False;
  lst_HTML.Visible := False;
  mem_Text.Visible := False;
  Repaint;
  drv_Drive.Visible := True;
  dir_Directory.Visible := True;
  fil_File.Visible := True;
  cmb_FileType.Visible := True;
  lst_HTML.Visible := True;
  mem_Text.Visible := True;
end;

procedure Tfrm_Main.men_EUCClick(Sender: TObject);
begin
  men_ShiftJIS.Checked := False;
  men_EUC.Checked := True;
  men_UTF8.Checked := False;

  NowCode := EUC_JP;
end;

procedure Tfrm_Main.men_FindClick(Sender: TObject);
begin
  ReplaceMode := False;
  frm_FindReplace.Show;
end;

procedure Tfrm_Main.men_FindReplaceBackClick(Sender: TObject);
begin
  if ReplaceMode then
  begin
    if FindWord <> '' then
      ReplaceString(FindWord, ReplaceWord, RegChecked, CrLfChecked, True);
  end
  else
  begin
    if FindWord <> '' then
      FindString(FindWord, RegChecked, True);
  end;
end;

procedure Tfrm_Main.men_FindReplaceNextClick(Sender: TObject);
begin
  if ReplaceMode then
  begin
    if FindWord <> '' then
      ReplaceString(FindWord, ReplaceWord, RegChecked, CrLfChecked, False);
  end
  else
  begin
    if FindWord <> '' then
      FindString(FindWord, RegChecked, False);
  end;
end;

procedure Tfrm_Main.men_FontClick(Sender: TObject);
begin
  dlg_Font.Font.Assign(mem_Text.Font);
  if dlg_Font.Execute then
    mem_Text.Font.Assign(dlg_Font.Font);
end;

procedure Tfrm_Main.men_HTMLEditClick(Sender: TObject);
begin
  frm_ListEdit.ShowModal;
end;

procedure Tfrm_Main.men_LFClick(Sender: TObject);
begin
  BRCode := #10;

  men_CRLF.Checked := False;
  men_LF.Checked := True;
  men_CR.Checked := False;
end;

procedure Tfrm_Main.men_ListExportClick(Sender: TObject);
begin
  if dlg_HTMLSave.Execute then
  begin
    try
      HTMLList.SaveToFile(dlg_HTMLSave.FileName);
    except
      MessageBeep(MB_ICONHAND);
      MessageDlg(html_error1, mtError, [mbOk], -1);
    end;
  end;
end;

procedure Tfrm_Main.men_ListImportClick(Sender: TObject);
begin
  if dlg_HTMLOpen.Execute then
  begin
    try
      HTMLList.Clear;
      HTMLList.LoadFromFile(dlg_HTMLOpen.FileName);
    except
      MessageBeep(MB_ICONHAND);
      MessageDlg(html_error2, mtError, [mbOk], -1);
    end;
  end;
end;

procedure Tfrm_Main.men_NewClick(Sender: TObject);
var
  mr: Integer;

begin
  if LoadData[TabId] <> mem_Text.Text then
  begin
    Beep;
    mr := MessageDlg(html_message1, mtConfirmation, [mbYes, mbNo, mbCancel], -1);
    if mr = mrYes then
    begin
      if FilePath[TabId] <> '' then
        SaveFile(FilePath[TabId])
      else
      begin
        if frm_SaveAs.ShowModal = mrCancel then
          Exit;
      end;
    end
    else if mr = mrCancel then
      Exit;
  end;

  FilePath[TabId] := '';
  Caption := html_title;
  MultiTab[TabId].Caption := html_caption7;
  lbl_FileName.Caption := '';
  LoadData[TabId] := '';
  mem_Text.Text := '';
  SetFileSize;

  men_UndoClear.Click;
end;

procedure Tfrm_Main.men_OpenClick(Sender: TObject);
var
  mr: Integer;
  LoadFile: TextFile;
  LoadChar: Char;
  LoadText: String;

begin
  if LoadData[TabId] <> mem_Text.Text then
  begin
    Beep;
    mr := MessageDlg(html_message1, mtConfirmation, [mbYes, mbNo, mbCancel], -1);
    if mr = mrYes then
    begin
      if FilePath[TabId] <> '' then
        SaveFile(FilePath[TabId])
      else
      begin
        if frm_SaveAs.ShowModal = mrCancel then
          Exit;
      end;
    end
    else if mr = mrCancel then
      Exit;
  end;

  if FileExists(fil_File.FileName) then
  begin
    AssignFile(LoadFile, fil_File.FileName);

    try
      Reset(LoadFile);

      LoadText := '';
      while not(EOF(LoadFile)) do
      begin
        Read(LoadFile, LoadChar);
        Insert(LoadChar, LoadText, Length(LoadText) + 1);
      end;
      
      CloseFile(LoadFile);

      if Pos(#13#10, LoadText) = 0 then
      begin
        if Pos(#13, LoadText) <> 0 then
          LoadText := StringReplace(LoadText, #13, #13#10, [rfReplaceAll])
        else if Pos(#10, LoadText) <> 0 then
          LoadText := StringReplace(LoadText, #10, #13#10, [rfReplaceAll]);
      end;
      mem_Text.Text := StrDecode(LoadText, NowCode);
      LoadData[TabId] := mem_Text.Text;

      FilePath[TabId] := fil_File.FileName;
      Caption := html_title + ' - ' + FilePath[TabId];
      if Copy(FilePath[TabId], Length(FilePath[TabId]) - 4, 5) = '.html' then
        MultiTab[TabId].Caption := NameGet(LoadData[TabId], ExtractFileName(fil_File.FileName))
      else
        MultiTab[TabId].Caption := ExtractFileName(fil_File.FileName);
      lbl_FileName.Caption := FilePath[TabId];
      SetFileSize;

      men_UndoClear.Click;
    except
      try
        CloseFile(LoadFile);
      except
      end;
      MessageBeep(MB_ICONHAND);
      MessageDlg(html_error2, mtError, [mbOk], -1);
    end;
  end
  else
  begin
    MessageBeep(MB_ICONEXCLAMATION);
    MessageDlg(html_error3, mtWarning, [mbOk], -1);
  end;
end;

procedure Tfrm_Main.men_PasteClick(Sender: TObject);
var
  Clip: TClipboard;

begin
  Clip := Clipboard;

  mem_Text.SelText := Clip.AsText;
end;

procedure Tfrm_Main.men_PreExportClick(Sender: TObject);
begin
  if dlg_PresetSave.Execute then
  begin
    try
      PresetList.SaveToFile(dlg_PresetSave.FileName);
    except
      MessageBeep(MB_ICONHAND);
      MessageDlg(html_error6, mtError, [mbOk], -1);
    end;
  end;
end;

procedure Tfrm_Main.men_PreImportClick(Sender: TObject);
begin
  if dlg_PresetOpen.Execute then
  begin
    try
      PresetList.Clear;
      PresetList.LoadFromFile(dlg_PresetOpen.FileName);
    except
      MessageBeep(MB_ICONHAND);
      MessageDlg(html_error2, mtError, [mbOk], -1);
    end;
  end;
end;

procedure Tfrm_Main.men_PreNewClick(Sender: TObject);
var
  mr: Integer;

begin
  if LoadData[TabId] <> mem_Text.Text then
  begin
    Beep;
    mr := MessageDlg(html_message1, mtConfirmation, [mbYes, mbNo, mbCancel], -1);
    if mr = mrYes then
    begin
      if FilePath[TabId] <> '' then
        SaveFile(FilePath[TabId])
      else
      begin
        if frm_SaveAs.ShowModal = mrCancel then
          Exit;
      end;
    end
    else if mr = mrCancel then
      Exit;
  end;

  FilePath[TabId] := '';
  Caption := html_title;
  MultiTab[TabId].Caption := html_caption7;
  lbl_FileName.Caption := '';
  LoadData[TabId] := PresetList.Text;
  mem_Text.Text := PresetList.Text;
  SetFileSize;

  men_UndoClear.Click;
end;

procedure Tfrm_Main.men_PresetEditClick(Sender: TObject);
begin
  frm_PresetEdit.ShowModal;
end;

procedure Tfrm_Main.men_PreviewClick(Sender: TObject);
var
  i: Integer;
  FileName: String;
  SaveFile: TextFile;
  SaveText: String;
  ShellInfo: TShellExecuteInfo;

begin
  Beep;
  if MessageDlg('uEUgăvr[\܂B'#13#10'낵łH',
                mtInformation, [mbYes, mbNo], -1) = mrNo then
    Exit;

  i := 0;
  while FileExists('tmp' + IntToStr(i) + '.html') do
    i := i + 1;
  FileName := 'tmp' + IntToStr(i) + '.html';

  AssignFile(SaveFile, FileName);

  try
    ReWrite(SaveFile);

    ChDir(CurrentPath);
    SaveText := StrEncode(mem_Text.Text, NowCode);
    Write(SaveFile, SaveText);

    CloseFile(SaveFile);

    ShellInfo.cbSize := SizeOf(ShellInfo);
    ShellInfo.fMask := SEE_MASK_NOCLOSEPROCESS;
    ShellInfo.Wnd := Handle;
    ShellInfo.lpVerb := 'open';
    ShellInfo.lpFile := PAnsiChar(FileName);
    ShellInfo.lpParameters := nil;
    ShellInfo.lpDirectory := nil;
    ShellInfo.nShow := SW_SHOW;

    if ShellExecuteEx(@ShellInfo) then
    begin
      SetLength(Processes, Length(Processes) + 1);
      SetLength(TmpFileName, Length(TmpFileName) + 1);
      Processes[Length(Processes) - 1] := ShellInfo.hProcess;
      TmpFileName[Length(TmpFileName) - 1] := FileName;

      if Length(Processes) = 1 then
        SetTimer(Handle, TimerId, 1000, @TimerProc);
    end;
  except
    try
      CloseFile(SaveFile);
    except
    end;
    MessageBeep(MB_ICONEXCLAMATION);
    MessageDlg('Tempt@Cۑł܂łB', mtWarning, [mbOk], -1);
  end;
end;

procedure Tfrm_Main.men_RedoClick(Sender: TObject);
begin
  RedoFlg := True;

  case UndoList[TabId][UndoPoint[TabId]].UndoType of
    // }̃hD
    unInsert:
    begin
      mem_Text.SelStart := UndoList[TabId][UndoPoint[TabId]].UndoStartPoint;
      mem_Text.SelText := UndoList[TabId][UndoPoint[TabId]].HendoStr;
      if Length(UndoList[TabId][UndoPoint[TabId]].HendoStr) > 2 then
      begin
        mem_Text.SelStart := UndoList[TabId][UndoPoint[TabId]].UndoStartPoint;
        mem_Text.SelLength := Length(UndoList[TabId][UndoPoint[TabId]].HendoStr);
      end
      else
        mem_Text.SelStart := UndoList[TabId][UndoPoint[TabId]].UndoEndPoint;
    end;
    // 폜̃hD
    unDelete:
    begin
      mem_Text.SelStart := UndoList[TabId][UndoPoint[TabId]].UndoEndPoint;
      mem_Text.SelLength := Length(UndoList[TabId][UndoPoint[TabId]].MotoStr);
      mem_Text.SelText := '';
    end;
  end;

  // AhDʒüړ
  inc(UndoPoint[TabId]);
  if UndoPoint[TabId] >= UndoLength[TabId] then
  begin
    men_Redo.Enabled := False;
    men_RedoPop.Enabled := False;
  end;
  men_Undo.Enabled := True;
  men_UndoPop.Enabled := True;

  RedoFlg := False;
end;

procedure Tfrm_Main.men_ReplaceClick(Sender: TObject);
begin
  ReplaceMode := True;
  frm_FindReplace.Show;
end;

procedure Tfrm_Main.men_SaveAsClick(Sender: TObject);
begin
  frm_SaveAs.ShowModal;
end;

procedure Tfrm_Main.men_SaveClick(Sender: TObject);
begin
  if MessageDlg(html_message3, mtConfirmation, [mbYes, mbNo], -1) = mrYes then
  begin
    if FilePath[TabId] <> '' then
      SaveFile(FilePath[TabId])
    else
      frm_SaveAs.ShowModal;
  end;
end;

procedure Tfrm_Main.men_ShiftJISClick(Sender: TObject);
begin
  men_ShiftJIS.Checked := True;
  men_EUC.Checked := False;
  men_UTF8.Checked := False;

  NowCode := SHIFT_JIS;
end;

procedure Tfrm_Main.men_Short10Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(10, lst_HTML.ItemIndex)
    else
      SetShortCut(10, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[10]);
end;

procedure Tfrm_Main.men_Short11Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(11, lst_HTML.ItemIndex)
    else
      SetShortCut(11, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[11]);
end;

procedure Tfrm_Main.men_Short12Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(12, lst_HTML.ItemIndex)
    else
      SetShortCut(12, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[12]);
end;

procedure Tfrm_Main.men_Short1Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(1, lst_HTML.ItemIndex)
    else
      SetShortCut(1, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[1]);
end;

procedure Tfrm_Main.men_Short2Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(2, lst_HTML.ItemIndex)
    else
      SetShortCut(2, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[2]);
end;

procedure Tfrm_Main.men_Short3Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(3, lst_HTML.ItemIndex)
    else
      SetShortCut(3, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[3]);
end;

procedure Tfrm_Main.men_Short4Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(4, lst_HTML.ItemIndex)
    else
      SetShortCut(4, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[4]);
end;

procedure Tfrm_Main.men_Short5Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(5, lst_HTML.ItemIndex)
    else
      SetShortCut(5, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[5]);
end;

procedure Tfrm_Main.men_Short6Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(6, lst_HTML.ItemIndex)
    else
      SetShortCut(6, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[6]);

end;

procedure Tfrm_Main.men_Short7Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(7, lst_HTML.ItemIndex)
    else
      SetShortCut(7, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[7]);
end;

procedure Tfrm_Main.men_Short8Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(8, lst_HTML.ItemIndex)
    else
      SetShortCut(8, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[8]);
end;

procedure Tfrm_Main.men_Short9Click(Sender: TObject);
begin
  if lst_HTML.Focused then
  begin
    if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < HTMLList.Count) then
      SetShortCut(9, lst_HTML.ItemIndex)
    else
      SetShortCut(9, -1);
  end
  else if mem_Text.Focused then
    PasteHTML(HTMLShort[9]);
end;

procedure Tfrm_Main.men_ShortClearClick(Sender: TObject);
var
  i: Integer;

begin
  for i := 1 to 12 do
    SetShortCut(i, -1);
end;

procedure Tfrm_Main.men_TabAddClick(Sender: TObject);
begin
  SetLength(MultiTab, Length(MultiTab) + 1);
  SetLength(FilePath, Length(FilePath) + 1);
  SetLength(LoadData, Length(LoadData) + 1);
  SetLength(TabString, Length(TabString) + 1);
  SetLength(TabPoint, Length(TabPoint) + 1);
  SetLength(UndoList, Length(UndoList) + 1);
  SetLength(UndoList[Length(UndoList) - 1], UndoMax);
  SetLength(UndoPoint, Length(UndoPoint) + 1);
  SetLength(UndoLength, Length(UndoLength) + 1);
  MultiTab[Length(MultiTab) - 1] := TTabSheet.Create(Self);
  MultiTab[Length(MultiTab) - 1].Caption := html_caption7;
  MultiTab[Length(MultiTab) - 1].PageControl := pgc_Text;
  MultiTab[Length(MultiTab) - 1].HandleNeeded;
  FilePath[Length(FilePath) - 1] := '';
  LoadData[Length(LoadData) - 1] := '';
  TabString[Length(TabString) - 1] := '';
  TabPoint[Length(TabPoint) - 1] := 0;
  UndoPoint[Length(UndoPoint) - 1] := 0;
  UndoLength[Length(UndoLength) - 1] := 0;

  men_TabDel.Enabled := True;
end;

procedure Tfrm_Main.men_TabDelClick(Sender: TObject);
var
  i: Integer;
  NewTabId: Integer;

begin
  if LoadData[pgc_Text.ActivePageIndex] <> mem_Text.Text then
    if MessageDlg(html_message8, mtInformation, [mbYes, mbNo], -1) = mrNo then
      Exit;

  for i := pgc_Text.ActivePageIndex to pgc_Text.PageCount - 2 do
  begin
    FilePath[i] := FilePath[i + 1];
    LoadData[i] := LoadData[i + 1];
    TabString[i] := TabString[i + 1];
    TabPoint[i] := TabPoint[i + 1];
    UndoList[i] := UndoList[i + 1];
    UndoPoint[i] := UndoPoint[i + 1];
    UndoLength[i] := UndoLength[i + 1];
  end;

  // ޔ
  if pgc_Text.ActivePageIndex = pgc_Text.PageCount - 1 then
    NewTabId := pgc_Text.ActivePageIndex - 1
  else
    NewTabId := pgc_Text.ActivePageIndex + 1;
  mem_Text.Parent := MultiTab[NewTabId];
  pgc_Text.ActivePage.Free;
  pgc_Text.ActivePage := MultiTab[NewTabId];
  TabId := pgc_Text.ActivePageIndex;
  if FilePath[TabId] = '' then
    Caption := html_title
  else
    Caption := html_title + ' - ' + FilePath[TabId];
  mem_Text.Text := TabString[TabId];
  SetFileSize;
  mem_Text.Parent := pgc_Text.ActivePage;

  SetLength(MultiTab, Length(MultiTab) - 1);
  SetLength(FilePath, Length(FilePath) - 1);
  SetLength(LoadData, Length(LoadData) - 1);
  SetLength(TabString, Length(TabString) - 1);
  SetLength(TabPoint, Length(TabPoint) - 1);
  SetLength(UndoList, Length(UndoList) - 1);
  SetLength(UndoPoint, Length(UndoPoint) - 1);
  SetLength(UndoLength, Length(UndoLength) - 1);

  if pgc_Text.PageCount <= 1 then
    men_TabDel.Enabled := False;
end;

procedure Tfrm_Main.men_TextPrevierClick(Sender: TObject);
var
  i, j: Integer;
  FileName: String;
  SaveFile: TextFile;
  SaveText: String;
  BodyFlg: Boolean;
  ShellInfo: TShellExecuteInfo;

begin
  Beep;
  if MessageDlg('eHTMLɕϊuEUgăvr[\܂B'#13#10'낵łH',
                mtInformation, [mbYes, mbNo], -1) = mrNo then
    Exit;

  i := 0;
  while FileExists('tmp' + IntToStr(i) + '.html') do
    i := i + 1;
  FileName := 'tmp' + IntToStr(i) + '.html';

  AssignFile(SaveFile, FileName);

  try
    ReWrite(SaveFile);

    ChDir(CurrentPath);
    SaveText := StrEncode(mem_Text.Text, NowCode);
    SaveText := StringReplace(SaveText, #13#10, '<br>'#13#10, [rfReplaceAll]);

    BodyFlg := False;
    for i := 0 to PresetList.Count - 1 do
    begin
      if not(BodyFlg) then
      begin
        if (Pos('body', PresetList[i]) <> 0) and not(Pos('/body', PresetList[i]) <> 0) then
        begin
          for j := i downto 0 do
            SaveText := PresetList[j] + #13#10 + SaveText;
          BodyFlg := True;
        end;
      end
      else
        SaveText := SaveText + #13#10 + PresetList[i];
    end;

    Write(SaveFile, SaveText);

    CloseFile(SaveFile);

    ShellInfo.cbSize := SizeOf(ShellInfo);
    ShellInfo.fMask := SEE_MASK_NOCLOSEPROCESS;
    ShellInfo.Wnd := Handle;
    ShellInfo.lpVerb := 'open';
    ShellInfo.lpFile := PAnsiChar(FileName);
    ShellInfo.lpParameters := nil;
    ShellInfo.lpDirectory := nil;
    ShellInfo.nShow := SW_SHOW;

    if ShellExecuteEx(@ShellInfo) then
    begin
      SetLength(Processes, Length(Processes) + 1);
      SetLength(TmpFileName, Length(TmpFileName) + 1);
      Processes[Length(Processes) - 1] := ShellInfo.hProcess;
      TmpFileName[Length(TmpFileName) - 1] := FileName;

      if Length(Processes) = 1 then
        SetTimer(Handle, TimerId, 1000, @TimerProc);
    end;
  except
    try
      CloseFile(SaveFile);
    except
    end;
    MessageBeep(MB_ICONEXCLAMATION);
    MessageDlg('Tempt@Cۑł܂łB', mtWarning, [mbOk], -1);
  end;
end;

procedure Tfrm_Main.men_UndoBufClick(Sender: TObject);
var
  NewBuf: String;
  i: Integer;

begin
  NewBuf := InputBox(html_caption8, html_message11, IntToStr(UndoMax));

  try
    UndoMax := StrToInt(NewBuf);
    for i := 0 to Length(UndoList) - 1 do
    begin
      SetLength(UndoList[i], UndoMax);
      if UndoLength[i] > UndoMax then
        UndoLength[i] := UndoMax;
      if UndoPoint[i] > UndoMax then
        UndoPoint[i] := UndoMax;
    end;
  except
    MessageBeep(MB_ICONHAND);
    MessageDlg(html_error7, mtError, [mbOk], -1);
  end;
end;

procedure Tfrm_Main.men_UndoClearClick(Sender: TObject);
begin
  // AhD̒0ɂ
  UndoPoint[TabId] := 0;
  UndoLength[TabId] := 0;
  men_Undo.Enabled := False;
  men_UndoPop.Enabled := False;
  men_Redo.Enabled := False;
  men_RedoPop.Enabled := False;
end;

procedure Tfrm_Main.men_UndoClick(Sender: TObject);
begin
  UndoFlg := True;

  case UndoList[TabId][UndoPoint[TabId] - 1].UndoType of
    // }̃AhD
    unInsert:
    begin
      mem_Text.SelStart := UndoList[TabId][UndoPoint[TabId] - 1].UndoStartPoint;
      mem_Text.SelLength := Length(UndoList[TabId][UndoPoint[TabId] - 1].HendoStr);
      mem_Text.SelText := '';
    end;
    // 폜̃AhD
    unDelete:
    begin
      mem_Text.SelStart := UndoList[TabId][UndoPoint[TabId] - 1].UndoEndPoint;
      mem_Text.SelText := UndoList[TabId][UndoPoint[TabId] - 1].MotoStr;
      mem_Text.SelStart := UndoList[TabId][UndoPoint[TabId] - 1].UndoStartPoint;
      if Length(UndoList[TabId][UndoPoint[TabId] - 1].MotoStr) > 2 then
        mem_Text.SelLength := Length(UndoList[TabId][UndoPoint[TabId] - 1].MotoStr);
    end;
  end;

  // AhDʒüړ
  dec(UndoPoint[TabId]);
  if UndoPoint[TabId] <= 0 then
  begin
    men_Undo.Enabled := False;
    men_UndoPop.Enabled := False;
  end;
  men_Redo.Enabled := True;
  men_RedoPop.Enabled := True;

  UndoFlg := False;
end;

procedure Tfrm_Main.men_UTF8Click(Sender: TObject);
begin
  men_ShiftJIS.Checked := False;
  men_EUC.Checked := False;
  men_UTF8.Checked := True;

  NowCode := UTF_8;
end;

procedure Tfrm_Main.men_VerClick(Sender: TObject);
begin
  frm_Version.ShowModal;
end;

procedure Tfrm_Main.men_WordWrapClick(Sender: TObject);
begin
  if men_WordWrap.Checked then
  begin
    // ܂Ԃ߂
    mem_Text.WordWrap := False;
    mem_Text.ScrollBars := ssBoth;
    men_WordWrap.Checked := False;
  end
  else
  begin
    // ܂Ԃ
    mem_Text.WordWrap := True;
    mem_Text.ScrollBars := ssVertical;
    men_WordWrap.Checked := True;
  end;
end;

procedure Tfrm_Main.SetHtmlList;
var
  i: Integer;

begin
  lst_HTML.Clear;

  for i := 0 to HTMLList.Count - 1 do
    lst_HTML.Items.Add(HTMLList1[i] + #9 + HTMLList2[i]);
end;

procedure Tfrm_Main.SetHTMLDesc(Index: Integer);
var
  DescStr: String;

begin
  if (Index >= 0) and (Index < HTMLList.Count) then
  begin
    DescStr := HTMLList1[Index] + #13#10;
    if HTMLList2[Index] <> '' then
      DescStr := DescStr + HTMLList2[Index] + #13#10;
    DescStr := DescStr + DescList[Index];
    lbl_Description.Caption := DescStr;
  end
  else
    lbl_Description.Caption := html_message4;
end;

procedure Tfrm_Main.PasteHtml(Index: Integer);
begin
  if (Index >= 0) and (Index < HTMLList.Count) then
  begin
    if HTMLList2[Index] = '' then
      mem_Text.SelText := HTMLList1[Index]
    else
      mem_Text.SelText := HTMLList1[Index] + mem_Text.SelText + HTMLList2[Index];

    mem_Text.SetFocus;
  end;
end;

procedure Tfrm_Main.pgc_TextChange(Sender: TObject);
begin
  TabFlg := True;
  
  TabString[TabId] := mem_Text.Text;
  TabPoint[TabId] := mem_Text.SelStart;
  mem_Text.Text := TabString[pgc_Text.ActivePageIndex];
  mem_Text.SelStart := TabPoint[pgc_Text.ActivePageIndex];
  // ܂ŏIĂ\
  mem_Text.Parent := pgc_Text.ActivePage;
  mem_Text.SetFocus;
  mem_Text.Perform(EM_SCROLLCARET, 0, 0);
  TabId := pgc_Text.ActivePageIndex;

  if FilePath[TabId] = '' then
    Caption := html_title
  else
    Caption := html_title + ' - ' + FilePath[TabId];
  lbl_FileName.Caption := FilePath[TabId];
  SetFileSize;

  if UndoPoint[TabId] > 0 then
  begin
    men_Undo.Enabled := True;
    men_UndoPop.Enabled := True;
  end
  else
  begin
    men_Undo.Enabled := False;
    men_UndoPop.Enabled := False;
  end;
  if UndoPoint[TabId] < UndoLength[TabId] then
  begin
    men_Redo.Enabled := True;
    men_RedoPop.Enabled := True;
  end
  else
  begin
    men_Redo.Enabled := False;
    men_RedoPop.Enabled := False;
  end;

  TabFlg := False;
end;

procedure Tfrm_Main.GetPos(var ACol, ARow: Integer);
begin
  if mem_Text.Text <> '' then
  begin
    ARow := mem_Text.Perform(EM_LINEFROMCHAR, -1, 0);
    ACol := mem_Text.SelStart - mem_Text.Perform(EM_LINEINDEX, ARow, 0);
  end
  else
  begin
    ARow := 0;
    ACol := 0;
  end;
end;

procedure Tfrm_Main.SetFileSize;
var
  Len: Integer;

begin
  Len := Length(LoadData[TabId]);
  if Len < 1024 then
    lbl_Size.Caption := IntToStr(Len) + ' B@@@'
  else if Len < 1024 * 1024 then
    lbl_Size.Caption := IntToStr(Trunc(Len / 1024)) + ' KB@@@'
  else if Len < 1024 * 1024 * 1024 then
    lbl_Size.Caption := IntToStr(Trunc(Len / (1024 * 1024))) + ' MB@@@'
  else
    lbl_Size.Caption := IntToStr(Trunc(Len / (1024 * 1024 * 1024))) + ' GB@@@';
end;

procedure Tfrm_Main.SaveFile(FileName: string);
var
  SaveFile: TextFile;
  SaveText: String;

begin
  AssignFile(SaveFile, FileName);

  try
    ReWrite(SaveFile);

    SaveText := StrEncode(mem_Text.Text, NowCode);
    SaveText := StringReplace(SaveText, #13#10, BRCode, [rfReplaceAll]);

    Write(SaveFile, SaveText);

    CloseFile(SaveFile);

    FilePath[TabId] := FileName;
    Caption := html_title + ' - ' + FilePath[TabId];
    if Copy(FilePath[TabId], Length(FilePath[TabId]) - 4, 5) = '.html' then
      MultiTab[TabId].Caption := NameGet(LoadData[TabId], ExtractFileName(fil_File.FileName))
    else
      MultiTab[TabId].Caption := ExtractFileName(fil_File.FileName);
    MultiTab[TabId].Caption := ExtractFileName(FileName);
    lbl_FileName.Caption := FilePath[TabId];
    LoadData[TabId] := mem_Text.Text;
    SetFileSize;

    men_UndoClear.Click;

    fil_File.Update;
  except
    try
      CloseFile(SaveFile);
    except
    end;
    MessageBeep(MB_ICONHAND);
    MessageDlg(html_error5, mtError, [mbOk], -1);
  end;
end;

procedure Tfrm_Main.SetShortCut(Num, Index: Integer);
var
  i: Integer;
  ShortStr: String;

begin
  HTMLShort[Num] := Index;

  ShortStr := '';
  for i := 1 to 12 do
  begin
    if (HTMLShort[i] >= 0) and (HTMLShort[i] < HTMLList.Count) then
      ShortStr := ShortStr + 'F' + IntToStr(i) + ':' + Copy(HTMLList[HTMLShort[i]], 1, 4)
    else
      ShortStr := ShortStr + 'F' + IntToStr(i) + ':NONE';

    if i <> 12 then
      ShortStr := ShortStr + ' ';
  end;

  lbl_ShortCut.Caption := ShortStr;
end;

procedure Tfrm_Main.FindString(const Search: string; RegFlg, RevFlg: Boolean);
var
  TempStr: String;
  FindPos: Integer;
  FindLength: Integer;
  RegSearch: TRegExp;
  MatCol: MatchCollection;
  Mat: Match;

begin
  FindPos := 0;
  FindLength := 0;
  if RevFlg then
  begin
    if RegFlg then
    begin
      RegSearch := TRegExp.Create(nil);
      RegSearch.Global := True;
      RegSearch.IgnoreCase := False;
      RegSearch.Pattern := Search;
      TempStr := Copy(mem_Text.Text, 1, mem_Text.SelStart);
      MatCol := MatchCollection(RegSearch.Execute(TempStr));
      if MatCol.Count > 0 then
      begin
        Mat := Match(MatCol.Item[MatCol.Count - 1]);
        FindPos := Mat.FirstIndex + 1;
        FindLength := Mat.Length;
        FindPos := FindPos + FindLength - 1;
      end;
      RegSearch.Free;
    end
    else
    begin
      TempStr := Copy(mem_Text.Text, 1, mem_Text.SelStart);
      FindLength := Length(Search);
      while True do
      begin
        if Pos(Search, TempStr) = 0 then
          break
        else
        begin
          FindPos := FindPos + Pos(Search, TempStr) + FindLength - 1;
          Delete(TempStr, 1, Pos(Search, TempStr) + FindLength - 1);
        end;
      end;
    end;

    if FindPos <> 0 then
    begin
      mem_Text.SelStart := FindPos - FindLength;
      mem_Text.SelLength := FindLength;
    end
    else
      MessageDlg(html_message5, mtInformation, [mbOk], -1);
  end
  else
  begin
    if RegFlg then
    begin
      RegSearch := TRegExp.Create(nil);
      RegSearch.Global := False;
      RegSearch.IgnoreCase := False;
      RegSearch.Pattern := Search;
      TempStr := Copy(mem_Text.Text, mem_Text.SelStart + mem_Text.SelLength + 1, Length(mem_Text.Text));
      MatCol := MatchCollection(RegSearch.Execute(TempStr));
      if MatCol.Count > 0 then
      begin
        Mat := Match(MatCol.Item[0]);
        FindPos := Mat.FirstIndex + 1;
        FindLength := Mat.Length;
      end
      else
        FindPos := 0;
      RegSearch.Free;
    end
    else
    begin
      TempStr := Copy(mem_Text.Text, mem_Text.SelStart + mem_Text.SelLength + 1, Length(mem_Text.Text));
      FindPos := Pos(Search, TempStr);
      FindLength := Length(Search);
    end;

    if FindPos <> 0 then
    begin
      mem_Text.SelStart := mem_Text.SelStart + mem_Text.SelLength + FindPos - 1;
      mem_Text.SelLength := FindLength;
    end
    else
      MessageDlg(html_message5, mtInformation, [mbOk], -1);
  end;
end;

procedure Tfrm_Main.ReplaceString(const Search, Replace: string;
  RegFlg, CrLfFlg, RevFlg: Boolean);
var
  RegSearch: TRegExp;
  MatCol: MatchCollection;
  Mat: Match;

begin
  if RegFlg then
  begin
    RegSearch := TRegExp.Create(nil);
    RegSearch.Global := False;
    RegSearch.IgnoreCase := False;
    RegSearch.Pattern := Search;
    MatCol := MatchCollection(RegSearch.Execute(mem_Text.SelText));
    if MatCol.Count > 0 then
    begin
      Mat := Match(MatCol.Item[0]);
      if Mat.Value = mem_Text.SelText then
      begin
        if CrLfFlg then
          mem_Text.Perform(EM_REPLACESEL, 1, LongInt(PChar(Replace + #13#10)))
        else
          mem_Text.Perform(EM_REPLACESEL, 1, LongInt(PChar(Replace)));
      end;
    end;
    RegSearch.Free;
  end
  else
  begin
    if mem_Text.SelText = Search then
    begin
      if CrLfFlg then
        mem_Text.Perform(EM_REPLACESEL, 1, LongInt(PChar(Replace + #13#10)))
      else
        mem_Text.Perform(EM_REPLACESEL, 1, LongInt(PChar(Replace)));
    end;
  end;

  FindString(Search, RegFlg, RevFlg);
end;

procedure Tfrm_Main.WMDropFiles(var Msg: TWMDropFiles);
var
  mr: Integer;
  FileName: array[0..255] of Char;
  Num: Integer;

begin
  if LoadData[TabId] <> mem_Text.Text then
  begin
    Beep;
    mr := MessageDlg(html_message1, mtConfirmation, [mbYes, mbNo, mbCancel], -1);
    if mr = mrYes then
    begin
      if FilePath[TabId] <> '' then
        SaveFile(FilePath[TabId])
      else
      begin
        if frm_SaveAs.ShowModal = mrCancel then
          Exit;
      end;
    end
    else if mr = mrCancel then
      Exit;
  end;

  Num := DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0);
  if Num >= 0 then
  begin
    DragQueryFile(Msg.Drop, 0, FileName, SizeOf(FileName));
    if FileExists(FileName) then
    begin
      try
        mem_Text.Clear;
        mem_Text.Lines.LoadFromFile(FileName);
        LoadData[TabId] := mem_Text.Text;

        FilePath[TabId] := FileName;
        Caption := html_title + ' - ' + FilePath[TabId];
        if Copy(FilePath[TabId], Length(FilePath[TabId]) - 4, 5) = '.html' then
          MultiTab[TabId].Caption := NameGet(LoadData[TabId], ExtractFileName(fil_File.FileName))
        else
        MultiTab[TabId].Caption := ExtractFileName(fil_File.FileName);
        MultiTab[TabId].Caption := ExtractFileName(FilePath[TabId]);
        lbl_FileName.Caption := FilePath[TabId];
        SetFileSize;

        men_UndoClear.Click;
      except
        MessageBeep(MB_ICONHAND);
        MessageDlg(html_error2, mtError, [mbOk], -1);
      end;
    end
    else
    begin
      MessageBeep(MB_ICONEXCLAMATION);
      MessageDlg(html_error3, mtWarning, [mbOk], -1);
    end;
  end;
end;

function Tfrm_Main.StrEncode(const S: String; EnCode: Integer): String;
var
  DestLen: Integer;
  W: WideString;
  ErrFlg: Boolean;

begin
  if EnCode = SHIFT_JIS then
  begin
    Result := S;
    exit;
  end;

  Result := '';
  ErrFlg := False;

  // ϊ̒𓾂
  DestLen := MultiByteToWideChar(SHIFT_JIS, 0, PChar(S), -1, nil, 0);
  if DestLen > 0 then
  begin
    SetLength(W, DestLen - 1);
    // jR[hϊ
    MultiByteToWideChar(SHIFT_JIS, 0, PChar(S), -1, PWideChar(W), DestLen - 1);

    // ϊ̒𓾂
    DestLen := WideCharToMultiByte(EnCode, 0, PWideChar(W), -1,  nil, 0, nil, nil);
    if DestLen > 0 then
    begin
      SetLength(Result, DestLen - 1);
      WideCharToMultiByte(EnCode, 0, PWideChar(W), -1, PChar(Result), DestLen - 1, nil, nil);
    end
    else
      ErrFlg := True;
  end
  else
    ErrFlg := True;

  if ErrFlg then
  begin
    MessageBeep(MB_ICONEXCLAMATION);
    MessageDlg('ϊł܂B', mtWarning, [mbOk], -1);
    Result := S;
  end;
end;

function Tfrm_Main.StrDecode(const S: String; EnCode: Integer): String;
var
  DestLen: Integer;
  W: WideString;
  ErrFlg: Boolean;

begin
  if EnCode = SHIFT_JIS then
  begin
    Result := S;
    exit;
  end;

  Result := '';
  ErrFlg := False;

  // ϊ̒𓾂
  DestLen := MultiByteToWideChar(EnCode, 0, PChar(S), -1, nil, 0);
  if DestLen > 0 then
  begin
    SetLength(W, DestLen - 1);
    // jR[hϊ
    MultiByteToWideChar(EnCode, 0, PChar(S), -1, PWideChar(W), DestLen - 1);

    // ϊ̒𓾂
    DestLen := WideCharToMultiByte(SHIFT_JIS, 0, PWideChar(W), -1,  nil, 0, nil, nil);
    if DestLen > 0 then
    begin
      SetLength(Result, DestLen - 1);
      WideCharToMultiByte(SHIFT_JIS, 0, PWideChar(W), -1, PChar(Result), DestLen - 1, nil, nil);
    end
    else
      ErrFlg := True;
  end
  else
    ErrFlg := True;

  if ErrFlg then
    Result := S;
end;

procedure Tfrm_Main.UndoAdd(UNData: TUndo);
var
  i: Integer;

begin
  if (UndoLength[TabId] < UndoMax) or (UndoPoint[TabId] < UndoLength[TabId]) then
  begin
    // ʏ̃AhDǉ
    UndoList[TabId][UndoPoint[TabId]] := UNData;
    inc(UndoPoint[TabId]);
    UndoLength[TabId] := UndoPoint[TabId];
  end
  else
  begin
    // 攲ǉ
    for i := UndoMax - 1 downto 1 do
      UndoList[TabId][i - 1] := UndoList[TabId][i];
    UndoList[TabId][UndoMax - 1] := UNData;
  end;

  men_Undo.Enabled := True;
  men_UndoPop.Enabled := True;
  men_Redo.Enabled := False;
  men_RedoPop.Enabled := False;
end;

function Tfrm_Main.NameGet(ReadData, AnotherName: String): String;
var
  i: Integer;
  ReadString: TStringList;
  TitleFlg: Boolean;

begin
  Result := AnotherName;
  ReadString := TStringList.Create;
  ReadString.Text := ReadData;

  TitleFlg := False;
  for i := 0 to ReadString.Count - 1 do
  begin
    if TitleFlg then
    begin
      if Pos('</TITLE>', UpperCase(ReadString[i])) <> 0 then
      begin
        Result := Result + Copy(ReadString[i], 1, Pos('</TITLE>', UpperCase(ReadString[i])) - 1);

        break;
      end
      else
        Result := Result + ReadString[i];
    end
    else
    begin
      if Pos('<TITLE>', UpperCase(ReadString[i])) <> 0 then
      begin
        if Pos('</TITLE>', UpperCase(ReadString[i])) <> 0 then
        begin
          Result := Copy(ReadString[i],
                         Pos('<TITLE>', UpperCase(ReadString[i])) + 7,
                         Pos('</TITLE>', UpperCase(ReadString[i])) - (Pos('<TITLE>', UpperCase(ReadString[i])) + 7));

          break;
        end
        else
          Result := Copy(ReadString[i],
                         Pos('<TITLE>', UpperCase(ReadString[i])) + 6,
                         Length(ReadString[i]));

        TitleFlg := True;
      end;
    end;
  end;

  ReadString.Free;
end;

procedure TimerProc(hwindow:HWND; Msg:UINT; ID:UINT; dwTime:DWORD);
var
  i: Integer;

begin
  i := 0;

  while i < Length(Processes) do
  begin
    if WaitForSingleObject(Processes[i], 0) <> WAIT_TIMEOUT then
    begin
      DeleteFile(TmpFileName[i]);
      SetLength(Processes, Length(Processes) - 1);
      SetLength(TmpFileName, Length(TmpFileName) - 1);
    end
    else
      inc(i);
  end;

  if Length(Processes) = 0 then
    KillTimer(frm_Main.Handle, ID);
end;

initialization
  // JgfBNg̎擾
  CurrentPath := ExtractFilePath(ParamStr(0));
  ChDir(CurrentPath);

  // Nt@C̎擾
  SetLength(FilePath, 1);
  SetLength(LoadData, 1);
  SetLength(TabString, 1);
  SetLength(TabPoint, 1);
  for IntParam := 1 to ParamCount do
    FilePath[0] := ParamStr(IntParam);
finalization

end.
